//  The implementation of the |Dict| class follows.

#include "EvalState.h"

//  First, we define our global dictionary, and initialize it.

Dict *globalDict ;

//  Now, the |DictEntry| stuff.

DictEntry::DictEntry(EvalState *es) {
   vals = 0 ;
   waiting = new List ;
   waiting->append(es->ESlink()) ;
}

DictEntry::~DictEntry(VOID) {
   if (waiting->length())
      error("! deleting a dictionary entry---with tasks still waiting?!!") ;
   delete waiting ;
   if (vals)
      delete vals ;
}

void DictEntry::addTask(class EvalState *es) {
   waiting->append(es->ESlink()) ;
}

void DictEntry::scheduleAllTasks() {
   while (waiting->length()) {
      EvalState *es = (EvalState *)waiting->takeFirstEl() ;
      es->schedule() ;
   }
}

//  Deleting a |Dict| involves deleting all of the |DictEntry| pointers.
//  This really belongs in the |Hash| class, but apparently you have to know
//  the type of what you are deleting in order to delete it.

Dict::~Dict(VOID) {
   int i ;
   struct _hashlink *hl, *n ;

   for (i=0; i<hashPrime; i++)
      for (hl = hashtable[i]; hl; hl = n) {
         n = hl->next ;
         delete (DictEntry *)hl->e ;
         delete hl ;
      }
   delete hashtable ;
}
