//  This file implements an integer set capability.

#include "misc.h"
#include "Object.h"

class IntSet : public Object {
   int size ;
   int wsize ;
   int *bits ;
   int forshortsets ;
 public:
   void clear(VOID) ;
   void addInt(int t) { bits[t >> 5] |= (1 << (t & 31)) ; }
   void subInt(int t) { bits[t >> 5] &= ~(1 << (t & 31)) ; }
   int member(int t) { bits[t >> 5] & (1 << (t & 31)) ; }
   int hash(int mod) ;
   int same(IntSet *p) ;
   int smallestMember(VOID) ;
   IntSet *copy(VOID) ;
   IntSet(int nsize) ;
   ~IntSet(VOID) { if (bits != &forshortsets) delete bits ; }
} ;
