//  This class handles the |Key| definition.  It is a dictionary for storing
//  keyword-tuples, and can be created with the Scheme function |make-dict|,
//  for local dictionaries.  There is also a global dictionary that is assumed
//  when |Null| is passed for the dictionary parameter.  It is based on the
//  |Hash| class.

#include "List.h"

//  Each element in our hash table is either a tuple, represented by a list
//  of expressions (in this case, an |Expr| list), or a list of |EvalState|
//  classes (see |Eval.cc|) waiting on a tuple in this dictionary with this
//  keyword (in this case, a real |List|.)

class Key : public Object {
   int inout ; // positive means too many outs; negative is too many ins.
   List *waiting ;        // who is waiting on me?
   class Expr *val ; // the value associated with this key, if any
public:
   Key() { inout = 0 ; waiting = new List ; val = 0 ; }
   ~Key(VOID) ;
   int voteIn(VOID) { return inout-- ; }
   int voteOut(VOID) { return inout++ ; }
   void addTask(class EvalState *es) ;
   class EvalState *getFirstTask(VOID) ;
   class Expr *getKeyVal() { return val ; }
   void setKeyVal(class Expr *e) { val = e ; }
   virtual const char *isa(VOID) { return "Key" ; }
} ;
