//  The implementation of |Object| need only define the |sername()|
//  function.

#include "Object.h"

//  We need to use the |tempstring()| function here.  Works on a large
//  `circular' buffer; best not to require strings longer than 256 chars.

#include "misc.h"

//  The |sername()| routine makes a unique name for an object out of its
//  |serial()| number and its |isa()| name.

char *Object::sername() {
   char *p = tempstring() ;
   sprintf(p, "<%s%d>", isa(), serial()) ;
   return(p) ;
}

//  The last thing we need to do is define our static variable.  This doesn't
//  compile under Amiga C++ if we use the |static| keyword in the |Object|
//  declaration, so we stick it in here instead.  We also maintain a counter
//  telling us how many of these objects have been deleted, so we can easily
//  tell how many are left.

int Object_sergen ;

int Object_deleted = 0 ;
