//  So everyone's an object these days.  Since C++ provides nothing in the
//  way of predefined classes or support structures, we've got to do
//  everything by hand.
//
//  We include |misc.h| for global definitions; everyone should include this
//  file.

#include "misc.h"

//  We need to `protect' this file against multiple inclusions.  This is
//  yet another flaw in C++.

#ifndef OBJECT_CLASS
#define OBJECT_CLASS

//  Things we want to have in common among all of our objects include
//  a function to say what type a particular function is.
//
//  We also want to stamp all objects with a unique `serial' number that
//  is perpetual (even if the object isn't) and unique.

extern int Object_deleted ;

extern int Object_sergen ;

class Object {
   int serialval ;
public:
   virtual const char *isa(VOID) { return "Object" ; }
   Object(VOID) { serialval = Object_sergen++ ; }
   int serial(VOID) { return serialval ; }
   char *sername(VOID) ;
   ~Object(VOID) { Object_deleted++ ; }
} ;
#endif
