//  This class holds a text object---usually an entire file of commands,
//  perhaps just a subroutine or macro definition.  We use a linked list
//  of lines.  We define a class |Line|, which is what is actually
//  returned and manipulated, as a subclass of |link|.  This makes it
//  easy for us to go forward and backwards in the file.

#include "List.h"

class Line : public link {
public:
   char *data(VOID) { return (char *)e ; }
   void changeData(char *s) { delete e ; e = newstring(s) ; }
   Line(char *s) : (newstring(s)) {}
   ~Line(VOID) { delete e ; }
} ;

//  Our actual |Text| class is straightforward; we can look at the
//  first line, go forwards or backwards from a given line, read the
//  text from a file and write it to another.  Using the functions
//  in |Line|, we can change the data.  Currently we can only append
//  lines to the end of the list, but that's easy to change when we
//  require the capability.

class Text : Object {
   List *lines ;
public:
   int readTextFromFile(char *s) ;
   int readTextFromFile(FILE *f) ;
   int writeTextToFile(char *s) ;
   int writeTextToFile(FILE *f) ;
   Line *firstLine(VOID) { return (Line *)lines->first() ; }
   Line *nextLine(Line *l) { return (Line *)lines->next((link *)l) ; }
   Line *prevLine(Line *l) { return (Line *)lines->prev((link *)l) ; }
   Line *appendLine(char *s) { return (Line *)lines->append((elem)s) ; }
   int numLines(VOID) { return lines->length() ; }
   Text(VOID) { lines = new List ; }
   ~Text(VOID) ;
   void clear(VOID) ;
   virtual const char *isa(VOID) { return "Text" ; }
} ;
