//  The accessors to the graphics display functions.

#ifndef DISPLAY_HEADER
#define DISPLAY_HEADER

extern struct display_routines {
#ifdef CPLUS
   void (*Close_window)(int w) ;
   int (*Open_window)(int x, int y) ;
   void (*Draw_line)(int x1, int y1, int x2, int y2) ;
   void (*Draw_box)(int x1, int y1, int x2, int y2) ;
   void (*Set_color)(int n) ;
   void (*Flush_window)(void) ;
   void (*Draw_circle)(int x1, int y1, int x2, int y2) ;
   void (*Label)(int x, int y, const char *s) ;
   int (*String_width)(const char *s) ;
   int (*String_height)(void) ;
#else
   void (*Close_window)() ;
   int (*Open_window)() ;
   void (*Draw_line)() ;
   void (*Draw_box)() ;
   void (*Set_color)() ;
   void (*Flush_window)() ;
   void (*Draw_circle)() ;
   void (*Label)() ;
   int (*String_width)() ;
   int (*String_height)() ;
#endif
} *cur_display, P_display, S_display ;

#define close_window (cur_display->Close_window)
#define open_window (cur_display->Open_window)
#define draw_line (cur_display->Draw_line)
#define draw_box (cur_display->Draw_box)
#define set_color (cur_display->Set_color)
#define flush_window (cur_display->Flush_window)
#define draw_circle (cur_display->Draw_circle)
#define label (cur_display->Label)
#define string_width (cur_display->String_width)
#define string_height (cur_display->String_height)

#endif
