//  A very short file to declare some utility functions.  We also define a
//  fairly versatile type |elem|, which we use as an untyped pointer.
//  This file has to be protected against multiple inclusions.

#ifndef MISC_HEADER
#define MISC_HEADER

#define __hp9000s300
#define _INCLUDE_POSIX_SOURCE

//  There is a fair amount of work we have to do to be compatible with both
//  C++ 1.2 (on the Amiga and DEC 3100) and 2.0 (really g++, on the bobcat.)
//  For one thing, the type declarations are slightly different.  For another,
//  overriding allocations (necessary for efficiency) is done differently
//  in the two implementations.
//
//  For now, if we are not compiling on the Amiga, we assume 2.0.

#ifndef AMIGA
#define CPLUSV2POINT0
#define GPLUSPLUS
#endif

#define CPLUS // for the display routines

#ifdef CPLUSV2POINT0
#define VOID void
#else
#define VOID /*nothing*/
#endif

#include <stdio.h>
#include <string.h>

extern void error(const char *s) ;
extern void error2(const char *f, const char *s) ;
extern void experror(const char *s, class Expr *e) ;
extern void startup(int argc, char *argv[]) ;
extern char *tempstring(void) ;
extern char *newstring(const char *s) ;
extern int ourtime(void) ;
#ifdef AMIGA
extern void exit(int) ;
extern long atol(const char *s) ;
#define bcopy(a,b,c) memcpy(b,a,c)
#endif
#ifdef GPLUSPLUS
#define link real_link                               // g++ requires this
#endif
extern FILE *stdbitbucket ;

//  Some debug stuff.  Legal flags are |b| for binding and |m| for macros.

extern long debug_flags ;
extern void set_debug_flags(const char *) ;
#define debugging(f) (debug_flags & (1L << ((f)-'a')))

typedef void *elem ;

#endif
