;
;   This is the actual skew calculations.  If you do all-pairs, the
;   total complexity is (number of nodes) * (number of edges).
;   The complexity for a single pair is the same.
;
(define (recurse-skew a b)
   (if (= a b) 0
      (let loop ((preds (aref *preds* a))
                 (curmin
         (let ((preds (aref *preds* b)))
            (if preds
               (let loop ((preds preds) (curmax -infty))
                  (if preds
                     (loop (cdr preds)
                           (sym-max curmax
                              (sym-add (aref *bounds* (car preds) b)
                                       (skew a (car preds)))))
                     curmax))
            infty))))
         (if preds
            (loop (cdr preds)
                  (sym-min curmin
                     (sym-add (aref *bounds* a (car preds))
                              (skew (car preds) b))))
            curmin))))
