;
;   A structure macro!  It's magic . . .
;
(defmacro (defstruct name . elements)
   (cons 'begin
      (cons 
          `(define ,(str->sym (strcat "new-" name))
                  (lambda () 
                     (let ((s (make-array #t ,(+ 1 (length elements)))))
                        (aset s 0 ,(list 'quote
                           (cons (strcat name)
                              (let loop ((el elements))
                                 (if el (cons (strcat (car el))
                                              (loop (cdr el))))))))
                        s)))
         (let loop ((el elements) (n 1))
              (if el
                 (cons
                    `(define ,(str->sym (strcat name "-" (car el)))
                             (lambda (dat) (aref dat ,n)))
                     (cons
                        `(define ,(str->sym (strcat "set-" name "-" (car el)))
                                (lambda (dat val) (aset dat ,n val)))
                        (loop (cdr el) (+ n 1)))))))))
;
;   This macro displays a structure.
;
(define (structdisplay s)
   (let ((template (aref s 0)))
      (display "{" (car template))
      (let loop ((el (cdr template)) (n 1))
         (if el
            (begin
               (display " " (car el) ":" (aref s n))
               (loop (cdr el) (+ n 1)))))
      (display "}")))
